=== debian/changelog ===
hsail-tools (0~20180830-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:54:21 +1100

hsail-tools (0~20180830-1build2) noble; urgency=medium

  * No-change rebuild against libelf1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 01 Mar 2024 00:59:23 +0000

hsail-tools (0~20180830-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:16:14 +0100

hsail-tools (0~20180830-1) unstable; urgency=medium

  * New upstream version
  * Bump standards version.
  * Stop building on big-endian systems, package is not ready.

 -- Matthias Klose <doko@debian.org>  Thu, 09 Jan 2020 21:14:26 +0100
