=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: hsail-tools
 Section: devel
 Priority: optional
-Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
 Uploaders: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 9),
   cmake,
@@ -9,7 +10,7 @@
   libelf-dev,
   libncursesw5-dev,
   re2c,
-Standards-Version: 4.1.0
+Standards-Version: 4.4.1
 Homepage: http://www.hsafoundation.com/hsa-developer-tools/
 
 Package: hsail-tools
